/* Insert missing gfx letters, by Tarek701.
 * This adds back Key, J, Q, V, X, Y, Z
 * gfx textures into the game.
 * ----------------------------------------
 * You may look into TextureAddresses.asm
 * for changing or adding more HUD textures.
 * ----------------------------------------
 * Hook.asm is made to load our existing code
 * into extended RAM and jump to it.
*/

.inc "Hook.asm"
.inc "TextureAddresses.asm"
.org 0x120FC00
ADDIU SP, SP, 0xFFE8
SW RA, 0x14(SP)

/* Insert Key letter */
LUI V0, @KeyRAM
ORI A0, V0, @KeyRAM
LUI V0, @MainPointer
ORI A1, V0, @Key
JAL 0x00278504
ORI A2, V0, @Key_End

/* Insert J letter */
LUI V0, @J_RAM
ORI A0, V0, @J_RAM
LUI V0, @MainPointer
ORI A1, V0, @J_letter
JAL 0x00278504
ORI A2, V0, @J_End

/* Insert V letter */
LUI V0, @V_RAM
ORI A0, V0, @V_RAM
LUI V0, @MainPointer
ORI A1, V0, @V_letter
JAL 0x00278504
ORI A2, V0, @V_End

/* Insert X letter */
LUI V0, @X_RAM
ORI A0, V0, @X_RAM
LUI V0, @MainPointer
ORI A1, V0, @X_letter
JAL 0x00278504
ORI A2, V0, @X_End

/* Insert Z letter */
LUI V0, @Z_RAM
ORI A0, V0, @Z_RAM
LUI V0, @MainPointer
ORI A1, V0, @Z_letter
JAL 0x00278504
ORI A2, V0, @Z_End

/* Insert Q letter */
LUI V0, @Q_RAM
ORI A0, V0, @Q_RAM
LUI V0, @MainPointer
ORI A1, V0, @Q_letter
JAL 0x00278504
ORI A2, V0, @Q_End

/* Display Text */
/*
LUI A2, 0x80C0 // Loads Top half of the text address
ORI A0, R0, 0x52 // sets X-Pos
ORI A2, A2, 0x00C0 // Adds Bottom half of the text address
JAL 0x802D66C0
ORI A1, R0, 0x0D // sets Y-Pos */

LW RA, 0x14(SP)
JR RA
ADDIU SP, SP, 0x18

/*.org 0x120FCC0
.asciiz "/ J Q V X Z"*/

.org 0x80A932
hex { 00 7F F4 00 } /* Segmented Pointer for Beta Key, '/' */

.org 0x80A8A2
hex { 00 7F F6 00 } /* Segmented Pointer for J letter. */

.org 0x80A8D2
hex { 00 7F F8 00 } /* Segmented Pointer for V letter. */

.org 0x80A8DA
hex { 00 7F FA 00 } /* Segmented Pointer for X letter. */

.org 0x80A8E2
hex { 00 7F FC 00 } /* Segmented Pointer for Z letter. */

.org 0x80A8BE
hex { 00 7F FE 00 } /* Segmented Pointer for Q letter. */